HubstaffDeveloper Portal

Attendance shifts

Monitor shift attendance, punctuality, and missed shifts

List organization attendance shifts

GET/v2/organizations/{organization_id}/attendance_shifts

Returns actual work shifts (clock-in/clock-out records) for the given organization.

Use date[start] and date[stop] to filter shifts that fall within the specified date range.

Note: The maximum allowed difference between date[start] and date[stop] is 31 days. Data is only available within organization’s retention period. If date[start] falls outside this window, the request will fail.

Parameters

NameInTypeDescription
organization_idrequired
pathinteger (int32)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
date[start]required
querystring (date)
Start date (ISO 8601)
date[stop]required
querystring (date)
Stop date (ISO 8601, Inclusive)
include
queryarray string[]
Specify related data to side load.
Possible valuesusersattendance_schedules

Responses

200A list of attendance shifts
object
  • attendance_shiftsarray
    array<object>
    items
    object

    AttendanceShift model

    • idinteger required

      Attendance shift ID

    • user_idinteger required

      User ID

    • organization_idinteger required

      Organization ID

    • attendance_schedule_idinteger required

      Attendance schedule ID

    • created_atstring required

      When the record was created

    • updated_atstring required

      When the record was last updated

    • datestring required

      Shift date

    • start_timestring required

      Shift start time

    • durationinteger required

      Shift duration

    • minimum_timeinteger required

      Minimum shift time

    • statusstring required

      Shift status

    • actual_start_timestring required

      Actual shift start time

    • actual_stop_timestring required

      Actual shift stop time

    • actual_durationinteger required

      Shift actual duration

Example response
json
{
  "attendance_shifts": [
    {
      "id": 0,
      "user_id": 0,
      "organization_id": 0,
      "attendance_schedule_id": 0,
      "created_at": "2024-01-15T10:30:00Z",
      "updated_at": "2024-01-15T10:30:00Z",
      "date": "2024-01-15",
      "start_time": "2024-01-15T10:30:00Z",
      "duration": 0,
      "minimum_time": 0,
      "status": "string",
      "actual_start_time": "2024-01-15T10:30:00Z",
      "actual_stop_time": "2024-01-15T10:30:00Z",
      "actual_duration": 0
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}